import { useQuery } from "@tanstack/react-query"
import { Inventories } from "../../types/services/inventory"
import { api } from "../api"

interface InventoriesQueryParams {
  page?: number
  limit?: number
  search?: string
}

export function useInventories(params: InventoriesQueryParams = {}) {
  const { page = 1, limit = 10, search = '', ...filters } = params

  return useQuery<Inventories>({
    queryKey: ['inventories', { page, limit, search, ...filters }],
    queryFn: async () => {
      const queryParams = new URLSearchParams()

      queryParams.append('page', page.toString())
      queryParams.append('limit', limit.toString())

      if (search) {
        queryParams.append('search', search)
      }

      Object.entries(filters).forEach(([key, value]) => {
        if (value !== undefined && value !== null && value !== '') {
          queryParams.append(key, value.toString())
        }
      })

      const res = await api.get(`/inventory?${queryParams.toString()}`)
      return res.data.data
    },
  })
}
